
;	>>> R.G.B.A. - Rasters Girls Beer Atari by JAC! <<<
;
;	Main screen routines.
;
;	@com.wudsn.ide.asm.mainsourcefile=RGBA.asm
;
;	Combinatio of PRIOR value and ther effect on horizontal split:
;	$00,$04 all players behind playfield
;	$01,$09 all players in front of playfield, P0/P1 in front of P2/P3
;	$02,$06 P0/P1 in front of playfield, P2/P3 behind playfield
;	$03,$05,$07,$0b,$0d,$0f P2/P3 in front of playfield, set playfield bit becomes black => hmmm
;	$08 P2/P3 behind $00/$01 but before $02/$03 => good
;	$0a$,0c,$0e P2/P3 with $00/$01 become black, P2/P3 behing $02/$03 => good

	.proc main_screen

	.var frame_color = 0 .byte

	.proc init
	ldx #<do_vbi
	ldy #>do_vbi
	jmp system.set_vbiv
	.endp

;===============================================================

	.local dl
	.byte $70,$70,$60+$80,$00
:24	.byte $70
	.byte $70+$80
	.byte $41,a(dl)
	.endl
	m_assert_same_1k dl

	.proc do_vbi
	jsr set_vbi_defaults
	mwa #dl dlptr
	mva #$23 dmactl
	mwa #dli_upper_border system.dliv
	mwa #do_kernel dli_upper_border.kernelv
	rts
	.endp


	.proc set_vbi_defaults	;Set cut colors for CIP & TIP mode, position PM graphics
	ldx #8
loop	mva cut.cut_data.colors,x colpm0,x
	dex
	bpl loop

	mva frame_color colpm1

	lda #%00001010
	sta grafm		;M1 right side border, M0 right girl border 
	lda #%00000011
	sta sizem
	sta sizep0

;	lda #0			;Re-use for size
	sta hposp1		;Make left side border invisible
	lda #mask_hposm1	;Make right side border visible
	sta hposm1
	lda #$80
	sta grafp0		;P0, left girl border
	sta grafp1		;P1, left side border
	rts
	.endp

;===============================================================

	.proc dli_upper_border
	kernelv = jump_kernel+1
	pha
	txa
	pha
	tya
	pha

;	lda #$ff		;Some free cycles
;	sta $hitclr
;	lda #$ff
;	sta hitclr
	sta wsync
	lda frame_color
	sta colbk
	lda #mask_hposp1	;Make left side border visible
	sta hposp1

jump_kernel
	jsr empty_procedure

	pla
	tay
	pla
	tax
	pla
	rti
	.endp	;End of dli

;===============================================================

	.proc do_kernel
	sta wsync
	lda #0
	sta colbk
	sta hposp1	;No left or right borders
	sta hposm1
	mwa #dli_lower_border system.dliv
	rts
	.endp
	
;===============================================================

	.proc dli_lower_border
	pha
	txa
	pha
	jsr show_lower_border.with_p1
	pla
	tax
	pla
	rti
	.endp
	
;===============================================================

	.proc show_lower_border	;Clear PRIOR and PM graphics 

	.if .def debug_mode
	jam			;Unclear entry point
	.endif

with_p1	lda #mask_hposp1
	sta hposp1
without_p1
	lda #0
	ldx frame_color
	sta wsync
	sta prior
	stx colbk	;Display lower frame border
	sta hposp0
	sta hposm0
	sta hposm1	;Make right side border invisible
	sta wsync
	sta colbk	;Lower frame border off
	rts
	.endp

;===============================================================

	.proc fade_border_in	;Called from DISCO part

	.var cnt = 16*4-1 .byte

	lda cnt
	beq skip
	dec cnt
skip	lsr
	lsr
	tax
	lda frame_colors,x
	sta frame_color
	rts
	
	.local frame_colors
	.byte 2,4,6,8,10,12,14,14,12,10,8,6,4,2,0,0
	.endl

	.endp

;===============================================================

	.proc clear_mask_p0_m0	;Reset black masks to outer borders and charsets to empty
	ldx #tip_lines-1
loop	lda #mask_hposp1
	sta tip_maskp0tab,x
	lda #mask_hposm1
	sta tip_maskm0tab,x
	lda #>cip_charset_empty
	sta cip_charsettab1,x
	ora #cip_chr_offset
	sta cip_charsettab2,x
	dex
	bpl loop
	rts
	.endp

;===============================================================

	.proc fade_lines		;Fade all screen lines, set jsr_adr to the callback address before

	.var step_rate = -1 .byte	;For initialization

	step_fix  = x2
	count	  = x3
	ycount    = x4

retry	lda random
	and #3
	tax
	lda step_rates,x
	cmp step_rate
	beq retry
	sta step_rate
	lda step_fixes,x
	sta step_fix

	lda #0
	sta count
	sta ycount

loop	lda cut.cut_visible		;No delay if there is nothing shown
	beq not_visible
	.if .def fast_mix
	lda count
	and #7
	bne not_visible
	.endif
	jsr sync.cnt
not_visible

	lda ycount
	asl
	cmp #tip_lines
	bcc no_warp
	eor #$ff
	adc #tip_lines*2-1
no_warp

jsr_adr	= *+1
	jsr empty_procedure

	clc
	lda ycount
	adc step_rate			;Add prime number
	cmp #tip_lines
	bcc no_overflow			;Wrap around
	sbc step_fix
no_overflow
	sta ycount
	inc count
	lda count
	cmp #tip_lines
	bne loop
	rts

	.local step_rates
	.byte 2,3,4,5		;Must be prime numbers
	.endl

	.local step_fixes
	.byte 99,100,99,99	;Multiple >=100 minus 1
	.endl
 
	.endp	;End of fade_lines

	.endp	;End of main_screen