
;	>>> R.G.B.A. - Rasters Girls Beer Atari by JAC! <<<
;
;	Character interlace effects.
;
;	@com.wudsn.ide.asm.mainsourcefile=..\RGBA.asm

	.proc cip

	xcount 		= x1
	ycount 		= x2
	buffer_ptr	= x3	;and x4
	sm_ptr 		= p1
	code_ptr	= p2
	sm_sta_lo_ptr	= p3
	sm_sta_hi_ptr	= p4

	cip_code	= effects_base


	.local cip_sm_offsets
lo	.rept cip_sm_lines,#
	.byte <[:1*cip_sm_width]
	.endr
hi	.rept cip_sm_lines,#
	.byte >[:1*cip_sm_width]
	.endr	
	.endl

;	Generates CHR content and code
	.proc init_chr_code		;IN: <X>=callback, low byte, <Y>=callback, high byte
	chr_ptr1 = p1
	chr_ptr2 = p2
	char_count = x1
	chroma1 = x2
	chroma2 = x3
	luma = x4
	tmp1 = x5
	tmp2 = x6

	luma1_9 = p3
	luma1_10 = p3+1
;	luma2_9 = p4
	luma2_10 = p4+1

	stx jsr_adr+1
	sty jsr_adr+2

	lda #0
	sta char_count
	mwa #cip_charset_c0+cip_charset_offset chr_ptr1
	mwa #cip_charset_c4+cip_charset_offset chr_ptr2
fill_64_loop

	lda init_chr_code.char_count
jsr_adr	jsr $ffff			;IN: <A>=char_count, OUT: <A>=chroma1=0..15,<Y>=chroma2=0..15, <X>=luma=0..31, can use <A>,<X>,<Y> and temp

	sta chroma1
	sty chroma2
	stx luma

	ldx #chroma1
	jsr double_nibble

	ldx #chroma2
	lda chroma2
	jsr double_nibble

	lda luma
	lsr
	and #$0e
	ldx #luma1_9
	jsr double_nibble

	lda luma
	lsr
	lsr
	sne
	lda #tip_black8
	ldx #luma1_10
	jsr double_nibble
	sta luma2_10

	lda luma
	cmp #30
	bcs is_even
	and #3
	tax
	clc
	lda luma1_9
	adc luma1_9tab,x
	sta luma1_9
	clc
	lda luma1_10
	adc luma1_10tab,x
	sta luma1_10

is_even
	ldy #0
c_loop	lda chroma1
	sta (chr_ptr1),y
	sta (chr_ptr2),y
	iny
	lda luma1_10
	sta (chr_ptr2),y
	lda luma1_9
	sta (chr_ptr1),y
  	iny
	lda chroma2
	sta (chr_ptr1),y
	sta (chr_ptr2),y
	iny
	lda luma2_10
	sta (chr_ptr1),y
	lda luma1_9
	sta (chr_ptr2),y
  	iny
  	cpy #8
  	bne c_loop
  	lda #8
  	ldx #chr_ptr1
  	jsr add_byte_to_pointer
  	ldx #chr_ptr2
  	jsr add_byte_to_pointer  

  	inc char_count
	lda char_count
	cmp #64
	jne fill_64_loop

	ldx #0
copy_64_loop
	lda cip_charset_c0+cip_charset_offset+$000,x
	sta cip_charset_c0+cip_charset_offset+$800,x
	sta cip_charset_d8+cip_charset_offset+$000,x
	sta cip_charset_d8+cip_charset_offset+$800,x
	sta cip_charset_d8+cip_charset_offset+$1000,x

	lda cip_charset_c0+cip_charset_offset+$100,x
	sta cip_charset_c0+cip_charset_offset+$900,x
	sta cip_charset_d8+cip_charset_offset+$100,x
	sta cip_charset_d8+cip_charset_offset+$900,x
	sta cip_charset_d8+cip_charset_offset+$1100,x

	lda cip_charset_c4+cip_charset_offset+$000,x
	sta cip_charset_c4+cip_charset_offset+$800,x
	sta cip_charset_dc+cip_charset_offset+$000,x
	sta cip_charset_dc+cip_charset_offset+$800,x
	sta cip_charset_dc+cip_charset_offset+$1000,x

	lda cip_charset_c4+cip_charset_offset+$100,x
	sta cip_charset_c4+cip_charset_offset+$900,x
	sta cip_charset_dc+cip_charset_offset+$100,x
	sta cip_charset_dc+cip_charset_offset+$900,x
	sta cip_charset_dc+cip_charset_offset+$1100,x
	
	inx
	bne copy_64_loop
	rts
	
	.local luma1_9tab
	.byte $00,$11,$00,$11
	.endl

	.local luma1_10tab
	.byte $00,$00,$11,$11
	.endl

	.proc double_nibble	;IN: <X>=zero page address
	sta temp+1
	asl
	asl
	asl
	asl
temp	ora #0
	sta $00,x
	rts
	.endp
	.endp

;===============================================================
	.proc init_chr_code_callbacks

	.proc shade	;One color, 32 lumas
	ldx #<callback
	ldy #>callback
	jmp init_chr_code

	.proc callback
	lsr
	and #31
	tax		;0..31
chroma = *+1
	lda #0		;0..15
	tay
	rts
	.endp		;End of callback

	.endp

	.proc rainbow	;64 Rainbow color
	ldx #<callback
	ldy #>callback
	jmp init_chr_code

	.proc callback
	and #15
	cmp #8
	bcc *+4
	eor #15
	asl
	asl
	tax

	lda init_chr_code.char_count
	lsr
	lsr
	lsr
	asl
	adc #1
	and #15
	tay
	rts
	.endp		;End of callback

	.endp		;End of rainbow

	.proc circle	;Red and blue, 32 lumas
	ldx #<callback
	ldy #>callback
	jmp init_chr_code
	
	.proc callback
	and #$1f
	tax		;Luma
	beq zero
	lda init_chr_code.char_count
	and #$20
	beq other_color
	lda #$7		;Chroma: blue
	.byte $2c
other_color
	lda #$3		;Chroma: red
zero	tay
	rts
	.endp		;End of callback

	.endp		;End of circle

	.endp		;End of init_chr_code_callbacks

;===============================================================

;	Generates the SM content and code
	.proc init_sm_code		;IN: <X>=callback, low byte, <Y>=callback, high byte
	lda #opcode.lda_abs
with_opcode				;IN: <A>=opcode (opcode.lda_abs or opcode.sta_abs),
	sta store_sta_smptr.opcode+1
	stx jsr_adr+1
	sty jsr_adr+2

	mwa #cip_sm sm_ptr
	mwa #cip_code code_ptr
	lda #<cip_sm_sta_lo
	sta sm_sta_lo_ptr
	sta sm_sta_hi_ptr
	lda #>cip_sm_sta_lo
	sta sm_sta_lo_ptr+1
	lda #>cip_sm_sta_hi
	sta sm_sta_hi_ptr+1

	lda #0
	sta ycount
loop_y	lda #0
	sta xcount
loop_x	ldy ycount
	lda xcount
	jsr cut.check_mask
	lsr
opcode	nop			;Modified between SEC (no store) and NOP (store) by sequencer
	ldy #0			;<Y>=0 is kept for the rest of this block
jsr_adr	jsr $ffff		;Called with <C>=0 (store)/<C>=1 (no store), <Y>=0, returns <Y>=0, <C>=0 (store)/1 (no store)
	bcc do_store
	tya
	sta (sm_sta_lo_ptr),y
	sta (sm_sta_hi_ptr),y
	beq no_store
do_store
	jsr store_sta_smptr
no_store
	inc sm_ptr
	inc sm_sta_lo_ptr
	inc sm_sta_hi_ptr
	bne no_inc_hi
	inc sm_ptr+1
	inc sm_sta_lo_ptr+1
	inc sm_sta_hi_ptr+1
no_inc_hi

	inc xcount
	lda xcount
	cmp #cip_sm_width
	bne loop_x
	lda #0
	sta xcount
	inc ycount
	lda ycount
	cmp #cip_sm_lines
	bne loop_y

	lda #opcode.rts
	.if .not .def debug_mode
	jmp store_code_a
	.else
	jsr store_code_a	;Store code end in $00 for debugging
	lda code_ptr
	sta $00
	lda code_ptr+1
	sta $01
	cmp #>[cip_code_max+1]
	bcc no_overrun
	jam
no_overrun
	rts
	.endif
	.endp
	
	.proc store_code	;JSR store_code, .byte length,data1,data2,....
	.var cnt .byte
	jsr get_byte
	sta cnt
	ldy #0
loop	jsr get_byte
	jsr store_code_a
	dec cnt
	bne loop
	rts

	.proc get_byte
	offset = 2		;Offset for inner JSR
	tsx
	inc $101+offset,x
	sne
	inc $102+offset,x
	lda $101+offset,x
	sta lda_adr+1
	lda $102+offset,x
	sta lda_adr+2
lda_adr	lda $ffff
	rts
	.endp

	.endp

	.proc store_code_ax	;IN: <A>, <X>; keeps <A> and <X> unchanged
	jsr store_code_a
	txa			;Fall trough
	.endp

	.proc store_code_a
	sta (code_ptr),y
	inw code_ptr
	rts
	.endp

	.proc store_sta_smptr
	lda code_ptr
	sta (sm_sta_lo_ptr),y
	lda code_ptr+1
	sta (sm_sta_hi_ptr),y

opcode	lda #opcode.lda_abs
	jsr store_code_a
	lda sm_ptr
	ldx sm_ptr+1
	jmp store_code_ax
	.endp

	.proc store_a_buffer_ptr_plus_x;IN: <A>=opcode, <X>=offset for buffer_ptr
	jsr store_code_a
	txa
	clc
	adc buffer_ptr
	ldx buffer_ptr+1
	scc
	inx
	jmp store_code_ax
	.endp

	.proc next_buffer_ptr
	inw buffer_ptr
	rts
	.endp

;===============================================================

	icl "cip/RGBA-CIP-Mosaic.asm"
	icl "cip/RGBA-CIP-Rasters.asm"
	icl "cip/RGBA-CIP-Plasma.asm"
	icl "cip/RGBA-CIP-Fire.asm"
	icl "cip/RGBA-CIP-Overlay.asm"
;	icl "cip/RGBA-CIP-Fractal.asm"
	icl "cip/RGBA-CIP-Rotator.asm"
	
	.endp	;End of cip