;
;	>>> R.G.B.A. - Rasters Girls Beer Atari by JAC! <<<
;
;	Fire effect.
;
;	@com.wudsn.ide.asm.mainsourcefile=..\RGBA.asm

	.proc fire

cip_buffer	= cip_free_f8	;$400 bytes, overlaps cip_rasters_base by $200 bytes
cip_buffer_width = 40
cip_buffer_lines = 25
cip_buffer_size	 = cip_buffer_width*cip_buffer_lines

	.local cip_buffer_addresses
lo	.rept cip_sm_lines,#
	.byte <[cip_buffer+:1*cip_buffer_width]
	.endr
hi	.rept cip_sm_lines,#
	.byte >[cip_buffer+:1*cip_buffer_width]
	.endr	
	.endl

	.proc init
	
	m_fill_memory cip_buffer cip_buffer_size $00

	ldx #<init_chr_code_callback
	ldy #>init_chr_code_callback
	jsr init_chr_code

	mwa #cip_buffer buffer_ptr
	lda #opcode.sta_abs			;Exceptional case to start with sta_abs
	ldx #<init_sm_code_callback
	ldy #>init_sm_code_callback
	jmp init_sm_code.with_opcode

 ;===============================================================
	.proc init_chr_code_callback
	.use effects.cip.init_chr_code

	lda char_count
	cmp #32
	bcc to_luma
	lsr
	cmp #$18
	bcs to_luma
	eor #$0f
to_luma	tax

	lda char_count
	jsr to_chroma
	clc
	adc #8
	jsr to_chroma
	tya
	rts

	.proc to_chroma
	cmp #32
	bcc black2
	cmp #48
	bcc yellow2
	ldy #$3
	.byte $2c
yellow2	ldy #$1
	.byte $2c
black2	ldy #$0
	rts
	.endp

	.endp
 ;===============================================================

	.proc init_sm_code_callback

	php

	lda #$ad		;LDA $buffer_ptr
	ldx #0
	jsr store_a_buffer_ptr_plus_x

	lda #$18		;CLC
	jsr store_code_a

	lda ycount
	cmp #cip_sm_lines-1
	bcs is_bottom_border

	lda xcount
	beq is_left_border
	lda #$6d		;ADC $buffer_ptr+cip_sm_width-1
	ldx #cip_sm_width-1
	jsr store_a_buffer_ptr_plus_x
is_left_border
	lda #$6d		;ADC $buffer_ptr+cip_sm_width
	ldx #cip_sm_width
	jsr store_a_buffer_ptr_plus_x

	lda xcount
	cmp #cip_sm_width-1
	beq is_right_border

	lda #$6d		;ADC $buffer_ptr+cip_sm_width+1
	ldx #cip_sm_width+1
	jsr store_a_buffer_ptr_plus_x
is_right_border

is_bottom_border
	jsr store_code		;LSR,LSR;STA
	.byte 3,$4a,$4a,$8d
	lda buffer_ptr
	ldx buffer_ptr+1
	jsr store_code_ax

	plp			;Generate STA code if mask is not set
	jmp next_buffer_ptr

	.endp			;End of init_sm_code_callback

	.endp			;End of init

;===============================================================

	.proc execute

	plot_worm_color = x5

	jsr cip_code

worm_color = *+1
	.proc fade_worms_in
	lda #0
	sta plot_worm_color

	cmp #63			;Maximum luma
	bcs not_fading_up
	inc worm_color
	bne skip

not_fading_up
	beq skip
	eor #127
	sta plot_worm_color
	beq skip
	inc worm_color
skip
	.endp


	.proc animate_worms
	inc cnt1

cnt1 	= *+1
	lda #0
	asl
	tax
cnt2	= *+1
	ldy #0
	inc cnt2
	jsr plot_worm

	lda cnt1
	asl
	clc
	adc #78
	tax
cnt3	= *+1
	ldy #123
	dec cnt3
	jsr plot_worm

	lda cnt1
	clc
	adc #38
	tax
cnt4	= *+1
	ldy #157
	dec cnt4
	dec cnt4		;Fall through
	.endp

;===============================================================

	.proc plot_worm		;IN: <X>, <Y>
	clc
	lda sinus.sintab64_256,x
	adc sinus.sintab64_256,y
	ror
	lsr
	clc
	adc #4
	sta xcount

	txa
	jsr sinus.reduce_sintab48_index
	tax

	tya
	jsr sinus.reduce_sintab48_index
	tay

	clc
	lda sinus.sintab48_83,x
	adc sinus.sintab48_83,y
	ror
	lsr
	adc #1
	sta ycount
	jsr plot_to_buffer
	rts

	.proc plot_to_buffer		;IN: xcount, ycount
	ldx ycount

	clc
	lda cip_buffer_addresses.lo,x
	adc xcount
	sta buffer_ptr
	lda cip_buffer_addresses.hi,x
	sta buffer_ptr+1

	cpx #cip_sm_lines
	bcs skip
	lda plot_worm_color
	ldy #0
	sta (buffer_ptr),y
	iny
	sta (buffer_ptr),y
	iny
	sta (buffer_ptr),y
	iny
	sta (buffer_ptr),y

	cpx #cip_sm_lines-1
	bcs skip
	ldy #cip_sm_width
	sta (buffer_ptr),y
	iny
	sta (buffer_ptr),y
	iny
	sta (buffer_ptr),y
	iny
	sta (buffer_ptr),y

	cpx #cip_sm_lines-2
	bcs skip
	ldy #cip_sm_width*2
	sta (buffer_ptr),y
	iny
	sta (buffer_ptr),y
	iny
	sta (buffer_ptr),y
	iny
	sta (buffer_ptr),y
skip	rts
	.endp		;End of plot_to_buffer
	.endp		;End of plot_worm
	.endp
	
	.endp		;End of fire
	
	m_info fire