
;	>>> R.G.B.A. - Rasters Girls Beer Atari by JAC! <<<
;
;	Disco font converter for "RGBA-DiscoFonts.g2f"
;	Save "*.all" and "*.fnt" in G2F in "Optymizing" mode using the "Disk" on the right.
;	Space=1, A-Z = 26, 0-9=10, !?&.=1 , all = 1+26+10+1=38 chars = $29 chars
;	Currently used chars as of 2012-11-10: $1b

;.def positioning_mode		;Activate marking for upper left corners

disco_max_used_char	= 37	;Adapt manually from char_offset after execution
disco_char_max_offset	= $ae	;Adapt manually from value of char_offset after exeuction

p1 			= $80
char_offset		= $e0	;ZP address of character offset

used_chars		= $3f00

	opt l+

	org $2000

	.proc main
	sei
	mva #0 $d40e
	mwa #dl $d402
	mva #>font $d409
	mva #$34 $d017
	mva #$38 $d016
	mva #$3e $d018
	
	jsr analyze_chars
	jsr convert_chars

	.proc jam
	ldx #2
loop	lda $d40b
	bne loop
	lda $d40b
	beq *-3
	dex
	bne loop

	lda char_offset
	ldx used_chars
	.byte $02
	.endp


;===============================================================
	.proc analyze_chars
	text_ptr=p1

	mwa #text text_ptr

	lda #0
	tax
clear_loop
	sta used_chars,x
	inx
	bne clear_loop

next_row
	ldy #0
	lda (text_ptr),y
	cmp #$ff
	beq return

	inw text_ptr	;Skip mode byte

next_char
	lda (text_ptr),y
	inw text_ptr
	pha
	and #$7f
	tax
	lda used_chars,x
	bne already_used
	txa
	sta used_chars,x
	inc used_chars
already_used
	pla
	bpl next_char
	bmi next_row

return
;	jmp jam
	rts
	.endp

;===============================================================

	.proc convert_chars
	.var char_number .byte
	.var used_char_number .byte

	mva #0 char_number
	mva #0 used_char_number
	mva #0 char_offset
loop	jsr convert_char
	inc char_number
	lda char_number
	cmp #[.len definitions]/4
	bne loop
	rts

	.proc convert_char
	.var char_x, char_y, char_length .byte
	.var char_ptr .byte
	
	lda char_number
	asl
	asl
	tay

	lda definitions,y	;Which character is procesed now?
	cmp #' '		;SPACE is always used
	beq is_space
	tax			;Use char value as index
	lda used_chars,x
	bne is_used
	rts

is_space
is_used	ldx used_char_number
	lda definitions,y
	sta output.char_codes,x
	lda definitions+1,y
	sta char_x
	lda definitions+2,y
	sta char_y
	lda definitions+3,y
	sta char_length

	lda char_offset		;Store offset
	sta output.char_offsets,x

	lda char_length		;Store length
	sta output.char_lengths,x

	lda char_y
	asl
	tay
	clc
	lda char_x
	adc screen.addresses,y 
	sta p1
	lda #0
	adc screen.addresses+1,y 
	sta p1+1

	.if .def positioning_mode
nokey	ldy #0
	lda $d20a
	sta (p1),y
	ldy #160
	sta (p1),y
	lda $d20f
	and #12
	cmp #12
	beq nokey

key	lda $d20f
	and #12
	cmp #12
	bne key
	.endif

	ldx char_offset
column_loop
	ldy #0
	lda (p1),y
	and #$7f
	sta output.char_data.line1,x
	jsr clear_char

	ldy #40
	lda (p1),y
	and #$7f
	sta output.char_data.line2,x
	jsr clear_char

	ldy #80
	lda (p1),y
	and #$7f
	sta output.char_data.line3,x
	jsr clear_char

	ldy #120
	lda (p1),y
	and #$7f
	sta output.char_data.line4,x
	jsr clear_char

	ldy #160
	lda (p1),y
	and #$7f
	sta output.char_data.line5,x
	jsr clear_char

	inw p1
	inx
	dec char_length
	bne column_loop

	inc used_char_number
	stx char_offset
	rts
	
	.proc clear_char
	lda char_offset
	sta (p1),y
	rts
	.endp
	
	.endp

	.endp	;End of convert_chars

	.endp	;End of main

;===============================================================

	.local definitions
 
	.macro m_char
	.byte :1,:2,:3,:4
	.endm

	m_char ' ',36,11,1
	m_char 'A',0,1,5
	m_char 'B',5,1,5
	m_char 'C',10,1,5
	m_char 'D',15,1,5
	m_char 'E',20,1,5
	m_char 'F',25,1,5
	m_char 'G',30,1,5
	m_char 'H',35,1,5

	m_char 'I', 0,6,2
	m_char 'J', 2,6,5
	m_char 'K', 7,6,5
	m_char 'L',12,6,5
	m_char 'M',17,6,6
	m_char 'N',23,6,5
	m_char 'O',28,6,5
	m_char 'P',33,6,5

	m_char 'Q', 0,11,5
	m_char 'R', 5,11,5
	m_char 'S',10,11,5
	m_char 'T',15,11,5
	m_char 'U',20,11,5
	m_char 'V',25,11,5
	m_char 'W',30,11,6

	m_char 'X', 0,16,5
	m_char 'Y', 5,16,5
	m_char 'Z',10,16,5
	m_char '!',15,16,2
	m_char '0',17,16,5
	m_char '1',22,16,2
	m_char '2',24,16,5
	m_char '3',29,16,5
	m_char '4',34,16,5	

	m_char '5', 0,21,5
	m_char '6', 5,21,5
	m_char '7',10,21,5
	m_char '8',15,21,5
	m_char '9',20,21,5
	m_char '?',25,21,5
	m_char '&',30,21,5
	m_char '.',36,21,2
	.endl
	
	.print .len definitions/4, " characters defined"
 
	.align $400
	.local dl
	.byte $70,$70,$70
	.byte $44,a(screen+40)
:24	.byte $04
	.byte $41,a(dl)
	.endl

	.local text
	icl "..\RGBA-Disco-Text.asm"
	.byte $ff	;End marker
	.endl

	.align $400
	.local font
	ins "RGBA-Disco-Font.fnt"
	.endl

	.align $1000	
	.local screen
	ins "RGBA-Disco-Font.all",+$400

	.local addresses
:32	.word screen+(#*40)
	.endl
	.endl

	org $4000
	.local output

	.local char_codes
	.ds disco_max_used_char
	.endl

	.local char_offsets
	.ds disco_max_used_char
	.endl

	.local char_lengths
	.ds disco_max_used_char
	.endl

	.local char_data
line1	.ds disco_char_max_offset
line2	.ds disco_char_max_offset
line3	.ds disco_char_max_offset
line4	.ds disco_char_max_offset
line5	.ds disco_char_max_offset
	.endl

	.endl

	.print "write ", output, " ", output+.len output-1, " C:\jac\system\Atari800\Programming\Demos\RGBA\font\RGBA-Disco-Font.bin"
	.print "CHAR_DATA offset:" , output.char_data-output
	run main
