;
;	>>> R.G.B.A. - Rasters Girls Beer Atari by JAC! <<<
;
;	Created 2010-09-19/2010-12-06 for the Sillyventure 2012 in Gdansk.
;
;	Ideas: Shade Bobs like Hardwired, Dark Water like Thomson (CHR mode)
;	Raster, Horizontal Sine Rasters, Horizontal Twister (2 colors per twister)
;
; Girls width: 	94,104, 88 pixel
; 		12, 13, 11 chars = 36 bytes

;Index	Register Original Color
;0	$d012	0	=> Color 0 for Gr. 10
;1	$d013	2
;2	$d014	4
;3	$d015	6
;4	$d016	8
;5	$d017	10
;6	$d018	12
;7	$d019	14
;8	$d01a	0	=> Color/Luma 0 for GR.9/11
switch_split = 0	;TODO

tip_lines	= 100
tip_frame_size	= 40*tip_lines

tip_priorbit	= $1
tip_prior09	= $40+tip_priorbit
tip_prior10	= $80+tip_priorbit
tip_prior11	= $c0+tip_priorbit
tip_prior_split	= $0a

;$00,$04 all players behind playfield
;$01,$09 all players in front of playfield, P0/P1 in front of P2/P3
;$02,$06 P0/P1 in front of playfield, P2/P3 behind playfield
;$03,$05,$07,$0b,$0d,$0f P2/P3 in front of playfield, set playfield bit become black => hmmm
;$08 P2/P3 behind $00/$01 but before $02/$03 => good
;$0a$,0c,$0e P2/P3 with $00/$01 become black, P2/P3 behing $02/$03 => good


mask_sm_lines	= 25
mask_sm_width	= 13
mask_sm_size	= mask_sm_lines*mask_sm_width
mask_pm_lines	= tip_lines

base		= $9000
tip_priortab1	= base+$000
tip_priortab2	= base+$000+tip_lines
cip_charsettab1	= base+$100
cip_charsettab2	= base+$100+tip_lines

sound_module	= $a000	;to $aa1f
sound_init	= $4f3
sound_player	= $503	;to $0db2
sound_zp	= $ec	;to $ff

cut_buffer	= $ae00	;= $1149 bytes
cut_buffer_size = 100+100+13*25+100*3*13	;$1149 bytes
cut_maskp0tab	= cut_buffer			;mask_pm_lines_lines bytes
cut_maskm0tab	= cut_maskp0tab+mask_pm_lines	;mask_pm_lines_lines bytes
cut_mask_sm	= cut_maskm0tab+mask_pm_lines	;up to 13*25=325=$145 bytes, ends before page boundary
cut_sm09	= cut_mask_sm+mask_sm_size	;3 times 100*13 bytes, ends at $bf3c


tip_dl1		= $d800	;to $da5x, graphics 9/10
tip_dl2		= $dc00	;to $de5x, graphics 10/9
tip_sm_width	= 40
tip_sm09	= $c000	;to $cf40
tip_sm10	= $e000	;to $ef40
tip_sm11	= $f000	;to $ff40


cip_chr_offset	= 4	;1 charset equals 4 pages, $c000-$cfff, up to 4 charsets, $d800-$fbff, up to 9 charsets
cip_sm_width	= 40
cip_sm_lines	= 25
cip_sm		= $fc00	;to $fee8
cip_code	= $6400	;preliminary

cnt	= $14


p1	= $40
p2	= $42
p3	= $44

x1	= $50
x2	= $51
x3	= $52
x4	= $53

inflate_used	= 0
inflate_zp	= $e0	;10 bytes
inflate_data	= $1000	;764 bytes

	opt l+

	org portb
	.byte $ff

	icl "RGBA-Kernel-Equates.asm"

	org $2000

	icl "RGBA-Kernel.asm"
	
	.if inflate_used = 1
	icl "RGBA-Inflater.asm"
	.endif
	.align $100

sintab
:2	.byte sin(32,31,256)
sintab83
:6	.byte sin(24,23,83)

	.proc add_byte_to_pointer	;IN: <A>=byte, <X>=pointer address in zeropage, 
	pha
	clc
	adc $00,x
	sta $00,x
	scc
	inc $01,x
	pla
	rts
	.endp

	.proc main
	
;	jsr story.main

	copy_memory sound_player_load sound_init [sound_player_load_end-sound_player_load]

	sei
	lda #0
	sta nmien
	lda #$fe
	sta portb

	jmp test_cip
	jmp test_tip

	.proc test_tip
	jsr tip_screen.generate_dls
	jsr tip_screen.generate_tabs
	jsr tip_screen.clear_sm

	mwa #tip_screen.do_vbi nmi.vbi.jump_vbi+1
	mwa #tip_screen.do_kernel nmi.dli.jump_kernel+1

	jsr init_screen
loop	lda #0
	jsr show_cut_tip
	lda #1
	jsr show_cut_tip
	lda #2
	jsr show_cut_tip
	lda #1
	jsr show_cut_tip
	jmp loop
	.endp
	
	.proc test_cip
	mwa #cip_screen.do_vbi nmi.vbi.jump_vbi+1
	mwa #cip_screen.do_kernel nmi.dli.jump_kernel+1
	jsr cip_screen.clear_sm

	clear_memory $c000 $1000
	clear_memory $d800 $1800

	jsr init_screen

loop	lda #0
	jsr show_cut_cip
	lda #1
	jsr show_cut_cip
	lda #2
	jsr show_cut_cip
	lda #1
	jsr show_cut_cip
	jmp loop
	.endp

;===============================================================
	.proc init_screen
	ldx #8
	mva:rpl cut.cut_data.colors,x $d012,x-

        mwa #tip_dl1 $d402
	mwa #nmi $fffa
	mwa #irq $fffe
	
	mva #0 cnt
	
;	lda #3
;	sta $d20f
;	lda #1
;	sta $d208
;	lda #4
;	sta $d200

	lda #$ff
	sta grafp2
	sta grafp3
	sta sizep2
	sta sizep3
	lda #$90
;	sta hposp2
	lda #$b0
;	sta hposp3
	jsr sound_init
;	cli
	lda vcount
	bne *-3
	mva #$c0 nmien
	mva #$22 dmactl	;$22 without PM DMA, $2e with PM DMA
	rts
	.endp

;===============================================================

	.proc wait_key
	jsr effects.cip.init

key1	jsr effects.cip.execute
	lda skstat
	and #12
	cmp #12
	beq key1
key2	lda skstat
	and #12
	cmp #12
	bne key2
	rts
	.endp

;===============================================================

	.proc show_cut_tip	;IN: <A>=cut_id 0..2

	jsr cut.fill_buffer
	jsr tip_screen.fill_sm

	jsr effects.tip_bars.do_effect

	jsr wait_key
	jsr tip_screen.clear_sm
	rts
	.endp

;===============================================================

	.proc show_cut_cip	;IN: <A>=cut_id 0..2

	jsr cut.fill_buffer
	jsr cip_screen.fill_sm
	jsr cip_screen.fill_chr

;	jsr effects.cip_bars.do_effect

	jsr wait_key
	jsr cip_screen.clear_sm
	rts
	.endp
	
	.endp

;===============================================================

	.proc cut
	.zpvar cut_id .byte
	.zpvar cut_width	.byte
	.zpvar cut_width4	.byte
	.zpvar cut_start	.byte
	.zpvar cut_end		.byte
	.zpvar cut_sm09_ptr	.word
	.zpvar cut_sm10_ptr	.word
	.zpvar cut_sm11_ptr	.word

	.proc fill_buffer	;IN: <A>=cut_id
	sta cut_id
	tax

	lda cut_data.width,x
	sta cut_width
	asl
	asl
	sec
	sbc #1
	sta cut_width4

	lda cut_data.offset,x
	sta cut_start
	clc
	adc cut_width
	sta cut_end

;	clc
	lda #<cut_sm09
	sta cut_sm09_ptr
	adc cut_data.sm_sizes.lo,x
	sta cut_sm10_ptr
	tay
	lda #>cut_sm09
	sta cut_sm09_ptr+1
	adc cut_data.sm_sizes.hi,x
	sta cut_sm10_ptr+1

;	clc
	tya
	adc cut_data.sm_sizes.lo,x
	sta cut_sm11_ptr
	lda cut_sm10_ptr+1
	adc cut_data.sm_sizes.hi,x
	sta cut_sm11_ptr+1

	.if inflate_used
	lda cut_data.addresses.lo,x
	sta inputPointer
	lda cut_data.addresses.hi,x
	sta inputPointer+1
	mwa #cut_buffer outputPointer
	jsr inflate
	.else
	lda cut_data.addresses.lo,x
	sta copy.source_adr
	lda cut_data.addresses.hi,x
	sta copy.source_adr+1
	mwa #cut_buffer copy.destination_adr
	mva #<cut_buffer_size copy.bytes
	mva #>cut_buffer_size copy.pages
	jsr copy.copy_memory
	.endif
	

	rts
	.endp

	.proc check_mask	;IN: <A>=x position between 0..39, <Y>=y position between 0..24, OUT: A=$00 (mask free)/$ff (mask set), destroys <A>, <X>
	cmp cut_end
	bcs mask_free
	sec
	sbc cut_start
	bcc mask_free
	tax
	lda cut_data.mask_addresses.lo,y
	sta load+1
	lda cut_data.mask_addresses.hi,y
	sta load+2
load	lda $ffff,x
 	rts
mask_free
 	lda #0
 	rts
 	.endp
 
 	.proc count_mask	;IN: <Y>=y position between 0..24, OUT: <Y>=number of non empty mask bytes
 	lda cut_data.mask_addresses.lo,y
	sta load+1
	lda cut_data.mask_addresses.hi,y
	sta load+2
	ldx #mask_sm_width-1
	ldy #0
load	lda $ffff,x
	beq free
	iny
free	dex
	bpl load
	rts
	.endp
	

;===============================================================

	.local cut_data		;about 30A4 bytes

	.local colors
	.byte 0,2,4,6,8,10,12,14,0
	.endl

width	.byte 12,13,11
offset	.byte 0,27,0

	.local addresses
lo	.byte <cut_data.cut1, <cut_data.cut2, <cut_data.cut3
hi	.byte >cut_data.cut1, >cut_data.cut2, >cut_data.cut3
	.endl

	.local sm_sizes
lo	.byte <[12*tip_lines], <[13*tip_lines], <[11*tip_lines]
hi	.byte >[12*tip_lines], >[13*tip_lines], >[11*tip_lines]
	.endl

 	.local mask_addresses
lo 	.rept mask_sm_lines,#
	.byte <[cut_mask_sm+:1*mask_sm_width]
 	.endr

hi	.rept mask_sm_lines,#
	.byte >[cut_mask_sm+:1*mask_sm_width]
 	.endr
 	.endl

	.if inflate_used = 1
cut1	ins "gfx/cut/chicks-1.cut.dfl"
cut2	ins "gfx/cut/chicks-2.cut.dfl"
cut3	ins "gfx/cut/chicks-3.cut.dfl"
	.else
cut1	ins "gfx/cut/chicks-1.cut"
cut2	ins "gfx/cut/chicks-2.cut"
cut3	ins "gfx/cut/chicks-3.cut"
	.endif


	.endl
	
	info cut_data

	.endp		;End of cut

;===============================================================

	.proc main_screen
	.endp

;===============================================================

	.proc tip_screen
	.proc generate_dls	;dl1 and dl2 are assumed to be at a page boundary
	dl_ptr = p1

	mwa #0 dl_ptr
	sta store_dl1+1
	sta store_dl2+1
	mva #>tip_dl1 store_dl1+2
	mva #>tip_dl2 store_dl2+2

	lda #$70
	jsr store_both
	jsr store_both
	lda #$60+$80
	jsr store_both
	lda #$00
	jsr store_both

	ldx #tip_lines
loop	jsr generate_gr11

	ora #>tip_sm09
	jsr store_dl1
	lda dl_ptr+1
	ora #>tip_sm10
	jsr store_dl2
	jsr next_line

	jsr generate_gr11

	ora #>tip_sm10
	jsr store_dl1
	lda dl_ptr+1
	ora #>tip_sm09
	jsr store_dl2
	jsr next_line

	bne loop
	lda #$41
	jsr store_both
	lda #<tip_dl1
	jsr store_both
	lda #>tip_dl1
	jmp store_both

generate_gr11
	jsr store_both_4f
	lda dl_ptr
	jsr store_both
	lda dl_ptr+1
	ora #>tip_sm11
	jsr store_both
	jsr store_both_4f
	lda dl_ptr
	jsr store_both
	lda dl_ptr+1
	rts

store_both_4f
	lda #$4f		;Fall though

store_both
	jsr store_dl2
store_dl1
	sta tip_dl1
        inw store_dl1+1
        rts

store_dl2
        sta tip_dl2
        inw store_dl2+1
        rts

next_line
        adw dl_ptr #tip_sm_width
       	dex
        rts
 
	.endp

	.proc generate_tabs
	tip_priorxx	= tip_prior09^tip_prior10

	ldx #0
prior_loop
 	lda #tip_prior11
	sta tip_priortab1,x
	sta tip_priortab2,x
	inx
	ldy #tip_prior09
	txa
	and #2
	beq *+4
	ldy #tip_prior10
	tya
	sta tip_priortab1,x
	eor #tip_priorxx
	sta tip_priortab2,x
	inx
	bne prior_loop
	rts
	.endp

	.proc clear_sm
	clear_memory tip_sm09 tip_frame_size
	clear_memory tip_sm10 tip_frame_size
	clear_memory tip_sm11 tip_frame_size
	rts
	.endp

	.proc fill_sm
	mwa #cut_sm09 p1

	lda #>tip_sm09
	jsr copy_frame
	lda #>tip_sm10
	jsr copy_frame
	lda #>tip_sm11
	jsr copy_frame
	rts

copy_frame		;IN: <A>=target high byte, x1=width, x2=target offset
	sta p2+1
	lda cut.cut_start
	sta p2
	ldx #tip_lines
copy_line
	ldy cut.cut_width
	dey
copy_byte
	lda (p1),y
	sta (p2),y
	dey
	bpl copy_byte

	.if switch_split = 1
	ldy #24		;TODO
	lda #$aa
fill_board
	sta (p2),y
	iny
	cpy #tip_sm_width
	bne fill_board
	.endif

	lda p1
	add cut.cut_width
	sta p1
	scc
	inc p1+1
	adw p2 #tip_sm_width
	dex
	bne copy_line
	rts
	.endp

	.proc do_vbi
	lda cnt
	lsr
	lda #>tip_dl1
	ldx #tip_prior09
	ldy #tip_prior10
	bcc is_dl1
	lda #>tip_dl2
	ldx #tip_prior10
	ldy #tip_prior09
is_dl1	sta dlptr+1
	stx do_kernel.kernel_loop.even_line+1
	sty do_kernel.kernel_loop.odd_line+1
	lda #0
	sta dlptr
	
	lsr $d209
	lda #<prior
	scc
	lda #<hitclr
	sta do_kernel.kernel_loop.split1+1
	sta do_kernel.kernel_loop.split2+1
	sta do_kernel.kernel_loop.split3+1
	sta do_kernel.kernel_loop.split4+1
	rts
	.endp

	.align 256

	.proc do_kernel
	ldx #0
	ldy #tip_prior_split
	lda #$30	;Make side border visible
	sta hposp1
	lda #$d0	;$8f/$90 for middle position
	sta hposm1
	.proc kernel_loop
	sta wsync
first_line
	lda #tip_prior11
	sta prior
	lda cut_maskp0tab,x
	sta hposp0
	lda cut_maskm0tab,x
	sta hposm0
	bit $00
:7	nop
split1	sty prior
	inx

	sta wsync
even_line
	lda #tip_prior10
	sta prior
	bit $00
:15	nop
split2	sty prior

	sta wsync
	lda #tip_prior11
	sta prior
	lda cut_maskp0tab,x
	sta hposp0
	lda cut_maskm0tab,x
	sta hposm0
	bit $00
:7	nop	
split3	sty prior
	inx
odd_line
	lda #tip_prior09
	sta wsync
	sta prior
	bit $00
	cpx #tip_lines
:15	nop
split4	sty prior
	bne kernel_loop
	.endp

	assert_same_page kernel_loop

	lda #0
	sta wsync
	sta prior
	sta hposp1	;Make side border invisible
	sta hposm1
	rts
	.end		;End of kernel

	.endp		;End of tip_screen
;===============================================================

	.proc cip_screen
	
	.proc clear_sm
	lda #0
	tax
loop	sta cip_sm,x
	sta cip_sm+$100,x
	sta cip_sm+$200,x
	sta cip_sm+$300-24,x	;Prevent overwriting $fff8-$ffff
	inx
	bne loop
	rts
	.endp

	.proc fill_sm
	ycount = x1
	xcount = x2
	charset_count = x3
	character_count = x4

	sm09_ptr = p1
	sm10_ptr = p2
	sm11_ptr = p3

	.zpvar sm_ptr .word
	.zpvar charset_ptr1 .word
	.zpvar charset_ptr2 .word

;	Source screens
	mwa cut.cut_sm09_ptr sm09_ptr
	mwa cut.cut_sm10_ptr sm10_ptr
	mwa cut.cut_sm11_ptr sm11_ptr

;	Target screen
	mva cut.cut_start sm_ptr
	mva #>cip_sm sm_ptr+1

	lda #0
	sta ycount
	sta charset_count
charset_loop
	lda #1			;Start new charset 
	sta character_count
	lda #8
	sta charset_ptr1
	sta charset_ptr2

	ldx charset_count
	lda charset_pages,x
;overflow beq overflow		;Optimization
	sta charset_ptr1+1
	ora #cip_chr_offset	;4 pages ahead
	sta charset_ptr2+1
y_loop
	lda ycount
	asl
	asl
	tay
	lda charset_ptr1+1
;	and #$fc		;Optimization
	sta cip_charsettab1,y
	sta cip_charsettab1+1,y
	sta cip_charsettab1+2,y
	sta cip_charsettab1+3,y
	ora #cip_chr_offset	;4 pages ahead
	sta cip_charsettab2,y
	sta cip_charsettab2+1,y
	sta cip_charsettab2+2,y
	sta cip_charsettab2+3,y

	ldy ycount		;Check if used characters will fit into charset limit
	jsr cut.count_mask
	tya
	clc
	adc character_count
	cmp #64
	bcc no_new_charset	;Yes, stay in current charset
	inc charset_count	;No, start next charset
	bne charset_loop

no_new_charset
	mva #0 xcount
x_loop	jsr one_character
	inc xcount
	lda xcount
	cmp cut.cut_width
	bne x_loop
	asl
	adc xcount
	ldx #sm09_ptr
	jsr add_byte_to_pointer
	ldx #sm10_ptr
	jsr add_byte_to_pointer
	ldx #sm11_ptr
	jsr add_byte_to_pointer

	lda #cip_sm_width
	sec
	sbc cut.cut_width
	ldx #sm_ptr
	jsr add_byte_to_pointer

	inc ycount
	lda ycount
	cmp #mask_sm_lines
	bne y_loop
	rts

	.proc one_character
	jsr char_to_charbuffer
	sec
	lda sm09_ptr
	sbc cut.cut_width4
	sta sm09_ptr
	scs
	dec sm09_ptr+1

	sec
	lda sm10_ptr
	sbc cut.cut_width4
	sta sm10_ptr
	scs
	dec sm10_ptr+1

	sec
	lda sm11_ptr
	sbc cut.cut_width4
	sta sm11_ptr
	scs
	dec sm11_ptr+1

	ldy ycount
	lda xcount
	clc
	adc cut.cut_start
	jsr cut.check_mask
	beq mask_not_set

	ldy #0
	lda character_count
	sta (sm_ptr),y

	ldy #7
charbuffer_to_charset
	lda charbuffer.page1,y
	sta (charset_ptr1),y
	lda charbuffer.page2,y
	sta (charset_ptr2),y
	dey
	bpl charbuffer_to_charset
	inc character_count

	lda #8
	ldx #charset_ptr1
	jsr add_byte_to_pointer 
	ldx #charset_ptr2
	jsr add_byte_to_pointer

mask_not_set
	inw sm_ptr
	rts

	.proc char_to_charbuffer
	ldy #0
	ldx #0
	jsr upper_lines
upper_lines
	lda (sm11_ptr),y	;Copy graphics 11
	sta charbuffer.page1,x
	sta charbuffer.page2,x
	lda (sm09_ptr),y	;Copy graphics 9
	sta charbuffer.page1+1,x
	lda (sm10_ptr),y	;Copy graphics 10
	sta charbuffer.page2+1,x
	jsr next_line

	lda (sm11_ptr),y	;Copy graphics 11
	sta charbuffer.page1,x
	sta charbuffer.page2,x
	lda (sm10_ptr),y	;Copy graphics 10
	sta charbuffer.page1+1,x
	lda (sm09_ptr),y	;Copy graphics 9
	sta charbuffer.page2+1,x

	.proc next_line
	stx savex+1
	lda cut.cut_width
	ldx #sm09_ptr
	jsr add_byte_to_pointer
	ldx #sm10_ptr
	jsr add_byte_to_pointer
	ldx #sm11_ptr
	jsr add_byte_to_pointer
savex	ldx #0
	inx
	inx
	rts
	.endp
	.endp

	.local charbuffer
	.local page1
	.ds 8
	.endl
	.local page2
	.ds 8
	.endl
	.endl
	.endp

	.local charset_pages
	.byte $c0,$c8,$d8,$e0,$e8,$00
	.endl

	.endp

	.proc fill_chr
	chr_ptr1 = p1
	chr_ptr2 = p2
	char_count = x1
	color = x2
	luma = x3
	temp = x4

	lda #0
	sta char_count
	mwa #$c200 chr_ptr1
	mwa #$c600 chr_ptr2
fill_64_loop
	lda char_count
	and #15
	cmp #8
	bcc *+4
	eor #15
	sta temp	;0..7
	asl
	asl
	asl
	asl
	ora temp
	sta luma

	lda char_count
	lsr
	lsr
	lsr
;	lsr
	asl
	adc #1
	and #15
	sta temp
	asl
	asl
	asl
	asl
	ora temp
	sta color

	ldy #0
c_loop	lda color
	sta (chr_ptr1),y
	sta (chr_ptr2),y
	iny
	lda luma
	sta (chr_ptr2),y
	asl
	sta (chr_ptr1),y
  	iny
	lda color
	sta (chr_ptr1),y
	sta (chr_ptr2),y
	iny
	lda luma
	sta (chr_ptr1),y
	asl
	sta (chr_ptr2),y
  	iny
  	cpy #8
  	bne c_loop
  	lda #8
  	ldx #chr_ptr1
  	jsr add_byte_to_pointer
  	ldx #chr_ptr2
  	jsr add_byte_to_pointer  

  	inc char_count
	lda char_count
	cmp #64
	bne fill_64_loop
;	.byte 2
	ldx #0
copy_64_loop
	lda $c200,x
	sta $ca00,x
	sta $da00,x
	sta $e200,x
	sta $ea00,x

	lda $c300,x
	sta $cb00,x
	sta $db00,x
	sta $e300,x
	sta $eb00,x

	lda $c600,x
	sta $ce00,x
	sta $de00,x
	sta $e600,x
	sta $ee00,x

	lda $c700,x
	sta $cf00,x
	sta $df00,x
	sta $e700,x
	sta $ef00,x

	inx
	bne copy_64_loop
	rts
	.endp

dl	.local
	.byte $70,$70,$60+$80,$00
	.byte $42,a(cip_sm)
:24	.byte $02
	.byte $41,a(dl)
	.endl

	.proc do_vbi
	lda cnt
	lsr
	lda #<cip_charsettab1
	ldx #tip_prior09
	ldy #tip_prior10
	bcc is_dl1
	lda #<cip_charsettab2
	ldx #tip_prior10
	ldy #tip_prior09
is_dl1	sta do_kernel.kernel_loop.even_line_charset+1
	stx do_kernel.kernel_loop.even_line+1
	sty do_kernel.kernel_loop.odd_line+1

	mwa #dl dlptr
	rts
	.endp

	.align 256

	.proc do_kernel
	ldx #0
	ldy #tip_prior11
	lda #$30	;Make side border visible
	sta hposp1
	lda #$d0	;$8f/$90 for middle position
	sta hposm1
	.proc kernel_loop
even_line_charset
	lda cip_charsettab1,x
	sta wsync
first_line
	sty prior
	sta chbase
	lda cut_maskp0tab,x
	sta hposp0
	lda cut_maskm0tab,x
	sta hposm0
	sta wsync
even_line
	lda #tip_prior10
	sta prior
	inx

	sta wsync
	sty prior
	lda cut_maskp0tab,x
	sta hposp0
	lda cut_maskm0tab,x
	sta hposm0
	sta wsync

odd_line
	lda #tip_prior09
	sta prior
	inx
;	sta wsync
	cpx #tip_lines
	bne kernel_loop
	.endp

	assert_same_page kernel_loop

	lda #0
	sta wsync
	sta prior
	sta hposp1	;Make side border invisible
	sta hposm1
	rts
	.endp		;End of do_kernel

	.endp		;End of cip_screen
;===============================================================

	.proc effects
	.proc tip_bars
	.proc do_effect

	ldx #0
	jsr fill_frame
	ldx #1
	jsr fill_frame
	rts

fill_frame
	stx mode	;0=luma, 1=chroma

	mva #>tip_sm09 p1+1
	mva #>tip_sm10 p2+1
	mva #>tip_sm11 p3+1
	lda #0
	sta p1
	sta p2
	sta p3

;	lda #0
	sta ycount
fill_line
	lda #0
	sta xcount
fill_byte
	lda ycount
	lsr
	lsr
	tay
	lda xcount
	jsr cut.check_mask
	bne no_store

	clc
	lda ycount
	adc xcount
	pha

	and #31
	cmp #16
	bcc *+4
	eor #31
	sta x1

	pla
;	lsr
	and #$f0
	ora x1
	sta color

	ldy xcount

	.if switch_split=1
	cpy #24
	bcc do_pattern
	lda #$1b
	sta (p1),y
	sta (p2),y
	sta (p3),y
	jmp no_store
	.endif

do_pattern
	lda mode
	bne chroma
	lda color
	and #15
	and #14
	sta x1
	asl
	asl
	asl
	asl
	ora x1
	sta (p1),y
	lsr
	sta (p2),y
	jmp no_store

chroma	lda color
	and #$f0
	sta x1
	lsr
	lsr
	lsr
	lsr
	ora x1
	sta (p3),y
	
no_store
	inc xcount

not11	lda xcount
	cmp #tip_sm_width
	bne fill_byte
	adw p1 #tip_sm_width
	adw p2 #tip_sm_width
	adw p3 #tip_sm_width

	lda cnt
delay	cmp cnt
	beq delay

	inc ycount
	lda ycount
	cmp #tip_lines
	jne fill_line
	rts

mode	.byte
ycount	.byte
xcount	.byte
color	.byte
	
	.endp

	.endp	;end of tip_bars

;===============================================================

	.proc cip
	xcount = x1
	ycount = x2
	sm_ptr = p1
	code_ptr = p2

	.proc store_code_ax
	jsr store_code_a
	txa		;Fall trough
	.endp

	.proc store_code_a
	sta (code_ptr),y
	inw code_ptr
	rts
	.endp

	.proc init
	mwa #cip_sm sm_ptr
	mwa #cip_code code_ptr
	lda #0
	sta ycount
loop_y	lda #0
	sta xcount
loop_x	ldy ycount
	lda xcount
	clc
;	adc #1
	jsr cut.check_mask
	bne no_store
	ldy #0
	lda #$18		;CLC
	jsr store_code_a
	lda #$bd		;LDA abs,x
	jsr store_code_a
	lda xcount
	asl
	asl
	ldx #>sintab
	jsr store_code_ax

	lda #$79		;ADC abs,y
	jsr store_code_a
	lda ycount
	asl
	ldx #>sintab
	jsr store_code_ax

	lda #$6a		;ROR to include carry
	jsr store_code_a
;	lda #$4a		;LSR
;	jsr store_code_a

	lda #$09
	ldx #$40
	jsr store_code_ax
	lda #$8d
	jsr store_code_a
	lda sm_ptr
	ldx sm_ptr+1
	jsr store_code_ax
no_store
	inw sm_ptr
	inc xcount
	lda xcount
	cmp #cip_sm_width
	bne loop_x
	lda #0
	sta xcount
	inc ycount
	lda ycount
	cmp #cip_sm_lines
	bne loop_y
	lda #$60
	jmp store_code_a
	.endp

	.proc execute
	.var xcnt .byte
	.var ycnt .byte
	ldy cnt
	ldx xcnt
	jsr cip_code
	lda xcnt
	clc
	adc #3
	sta xcnt

	rts
	.endp
	.endp
	.endp	;end of effects

;===============================================================

	.proc nmi
	bit $d40f
	jpl vbi

	.proc dli
	pha
	txa
	pha
	tya
	pha

	lda #%00001010	;+%0100
	sta grafm	;M1 right side border, M0 right girl border 
	lda #%00000011
	sta sizem
	sta wsync
	lda #$80
	sta grafp0	;P0, left girl border
	lda #$3
	sta sizep0
	lda #$80
	sta grafp1	;P1, left side border

jump_kernel
	jsr $ffff

	pla
	tay
	pla
	tax
	pla
	rti
	.endp	;End of dli

	.proc vbi
	sta $d40f
	pha
	txa
	pha
	tya
	pha

jump_vbi
	jsr $ffff

	jsr sound_player
	inc cnt
	pla
	tay
	pla
	tax
	pla
	rti
	.endp	;End of vbi
	
	.endp	;End of nmi


;	org $80

	.proc irq
;	sta save_a 
;	stx save_x
;	lda #0
;	sta irqen
;	lda #4
;	sta irqen
;
;	ldx #0
;line_cnt = *-1
;
;	lda tip_priortab1,x
;priortab_adr = *-2
;	inc line_cnt
;	sta prior
;	lda cut_maskp0tab,x
;;	sta hposp0
;;	stx $d01a
;;	lda xposm0tab,x
;;	sta hposm0
;	ldx #0
;save_x = *-1
;	lda #0
;save_a = *-1
	rti
	.endp

	org cip_code
	icl "RGBA-Story.asm"

sound_player_load
	ins "snd/RGBA-Quicky-Player-$04f3.bin"	;copy to $4f3
sound_player_load_end

	org sound_module
	ins "snd/RGBA-Quicky-Module-$a000.bin"

	run main
