;
;	>>> R.G.B.A. - Rasters Girls Beer Atari by JAC! <<<
;
;	TIP colors bar effect.
;
;	@com.wudsn.ide.asm.mainsourcefile=..\RGBA.asm

	.proc bars

;===============================================================

	.proc init

	ldx #<init_masks_callback
	ldy #>init_masks_callback
	jsr init_masks
	m_init_squares init_squares_callback 0

	mwa #empty_procedure sequencer.call_adr
	rts

	.proc init_masks_callback;IN: <X>=0...255, OUT: <A>=$00..fe (even values)
	txa
	and #$f0
	sta choma
	txa
	and #15
	cmp #8
	scc
	eor #15
	asl
choma	= *+1
	ora #$00
	rts
	.endp

	.proc init_squares_callback
	lda init_squares.shifted_value+1
	asl
	sta bar_squares,x
	rts
	.endp

	.endp

;===============================================================

	.proc execute
	count = x3

;===============================================================

	.proc vertical
	mva #0 count
loop1	lda count
	asl
	cmp #tip_lines
	bcc use
	eor #$ff
	adc #tip_lines*2-1
use	sta ycount
	mva #tip_pixel_width-1 xcount
loop2	lda ycount
	jsr plot_pixel
	dec xcount
	bpl loop2
	inc count
	lda count
	cmp #tip_lines
	bne loop1
	rts
	.endp

;===============================================================

	.proc horizontal
	mva #0 count
loop1	lda count
	asl
	cmp #tip_pixel_width
	bcc use
	eor #$ff
	adc #tip_pixel_width*2-1
use	sta xcount

	mva #tip_lines-1 ycount
loop2	lda xcount
	jsr plot_pixel
	dec ycount
	bpl loop2
	inc count
	lda count
	cmp #tip_pixel_width
	bne loop1
	rts
	.endp

;===============================================================

	.proc diagonal1
	mva #0 count
loop1	mva #0 ycount
	lda count
	cmp #[tip_pixel_width+tip_lines]/2
	bcc use
	eor #$ff
	adc #[tip_pixel_width+tip_lines]
	asl
	adc #1
	bne use2
use	asl
use2	sta xcount

loop2	lda ycount
	cmp #tip_lines
	bcs skip
	lda xcount
	cmp #tip_pixel_width
	bcs skip
	clc
	adc ycount
	jsr plot_pixel
skip	inc ycount
	dec xcount
	lda xcount
	cmp #-1
	bne loop2

	jsr sync.cnt

	inc count
	lda count
	cmp #tip_pixel_width+tip_lines
	bne loop1
	rts
	.endp

;===============================================================

	.proc square
part1	lda #0
	.byte $2c
part2	lda #tip_pixel_width/2
	clc
	sta count
	adc #[tip_pixel_width/2]
	sta compare+1
loop1	mva #tip_lines-1 ycount
loop2	lda count
	asl
	cmp #tip_pixel_width
	bcc use
	eor #$ff
	adc #tip_pixel_width*2-1
use	sta xcount
	asl
	tax
	ldy ycount
	lda bar_squares,x
	adc bar_squares,y
	jsr plot_pixel
	dec ycount
	bpl loop2
	jsr sync.cnt
	inc count
	lda count
compare	cmp #tip_pixel_width
	bne loop1
	rts
	.endp

	.endp	;End of execute
	
	.endp	;End of bars

